<template>
  <div class="wrapper-line-charts">
    <LineChart v-bind="lineChartProps" :height="300" />
  </div>
</template>

<script setup lang="ts">
import { computed } from 'vue'
import { LineChart, useLineChart } from 'vue-chart-3'
import { Chart, registerables } from 'chart.js'
import { formatNumber } from '@/utils'
Chart.register(...registerables)

const props = defineProps({
  labels: {
    type: Array,
    default: []
  },
  datasets: {
    type: Array,
    default: null
  },
  isMillions: {
    type: Boolean,
    default: false
  }
})

const lineData = computed(() => ({
  labels: props.labels,
  datasets: [
    {
      ...(props.datasets[0] as object),
      borderColor: '#2954E9',
      tension: 0.3,
      backgroundColor: '#f6fafe',
      pointRadius: 5,
      datalabels: { align: 'top' }
    }
  ]
}))

const { lineChartProps } = useLineChart({
  chartData: lineData,
  options: {
    layout: {
      padding: {
        top: 20,
        right: 20
      }
    },
    plugins: {
      legend: {
        display: false
      },
      datalabels: {
        formatter: function (value: number) {
          if (props.isMillions) {
            if (value === 0) return value
            if (value.toString().length < 7) return value
            return `${formatNumber(value)}m`
          }
          return value
        },
        align: 'top',
        anchor: 'end'
      }
    },
    scales: {
      y: {
        ticks: {
          callback: function (value: number) {
            if (props.isMillions) {
              if (value === 0) return value
              return `${formatNumber(value)} millions`
            }
            return value
          }
        }
      }
    }
  }
})
</script>

<style scoped>
.wrapper-line-charts {
  width: 100%;
}
</style>
